
void initMeterItems(void);
unsigned long long getEpochTimeWithMs(void);

#define NUMBER_OF_METERS 6 /* the number of meters we use */

#define METER_INDEX_TST  0 /* index of the button example meter data */
#define METER_INDEX_GAS  1 /* index of the gas meter data */
#define METER_INDEX_EL1  2 /* index of the Electricity 1 meter data */
#define METER_INDEX_EL2  3 /* index of the Electricity 2 meter data */
#define METER_INDEX_AU1  4 /* index of Auxiliary input 1 */
#define METER_INDEX_AU2  5 /* index of Auxiliary input 1 */


#define DEBOUNCE_TICK_THRESHOLD_MS 50 /* when two ticks are less than this time period apart, the second tick is ignored (debouncing) */
#define ACCUMULATE_TICK_THRESHOLD_SEC 30 /* how long (seconds) should the ticks be accumulated before a new data item is created? */

typedef struct
{
  portSHORT meterEnabled;  /* 0: item not used, 1: meter enabled */
  unsigned long long timeLastTick; /* when did the last tick occur? epoch time in seconds */
  unsigned long long timeBeforeLastTick; /* when did the tick before the last tick occur? epoch time in seconds */
  portLONG valueLastTick;   /* what value did we have at the last tick? */
  portLONG valueBeforeLastTick;   /* what value did we have at the tick before the last tick? */
  portLONG currentValue;  /* the value of the meter. gets incremented by the ISR */
} meterItem;

meterItem meterItems[NUMBER_OF_METERS]; /* the data for all the meters */

